package com.fuzamei.entity;


import java.io.Serializable;

import javax.validation.GroupSequence;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import org.hibernate.validator.constraints.NotBlank;



public class User implements Serializable{
	private int id;	//主键
	@NotNull(message = "用户编号不能为空字符串或者null",groups = {USERID.class})
	private int user_id;	//用户id
	@NotBlank(message = "用户名不能为空字符串或者null",groups = {ACCOUNT.class})
	private String account;	//用户名称
	@Size(min = 6,max = 8,message = "密码必须为6到10位",groups = {PASSWORD.class})
	private String password;	//用户密码
	@NotBlank(message = "随机数不能为空字符串或者null",groups = {RANDOM.class})
	private String random;		//随机数
	private String public_key;	//公钥
	private String private_key;	//私钥
	private String organization_name;	//机构名称
	@NotBlank(message = "用户名称不能为空字符串或者null",groups = {PERSONNAME.class})
	private String person_name;			//人员名称
	@NotNull(message = "用户角色id不能为空字符串或者null",groups = {ROLEID.class})
	private int role_id;				//角色id
	@NotBlank(message = "用户角色名称不能为空字符串或者null",groups = {ROLENAME.class})
	private String role_name;			//角色名称
	@NotBlank(message = "签名不能为空字符串或者null",groups = {SIGN.class})
	private String sign;			//注册时候的签名
	
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	public int getUser_id() {
		return user_id;
	}
	public void setUser_id(int user_id) {
		this.user_id = user_id;
	}
	public String getAccount() {
		return account;
	}
	public void setAccount(String account) {
		this.account = account;
	}
	public String getPassword() {
		return password;
	}
	public void setPassword(String password) {
		this.password = password;
	}
	public String getRandom() {
		return random;
	}
	public void setRandom(String random) {
		this.random = random;
	}
	public String getPublic_key() {
		return public_key;
	}
	public void setPublic_key(String public_key) {
		this.public_key = public_key;
	}
	public String getPrivate_key() {
		return private_key;
	}
	public void setPrivate_key(String private_key) {
		this.private_key = private_key;
	}
	public String getOrganization_name() {
		return organization_name;
	}
	public void setOrganization_name(String organization_name) {
		this.organization_name = organization_name;
	}
	public String getPerson_name() {
		return person_name;
	}
	public void setPerson_name(String person_name) {
		this.person_name = person_name;
	}
	public int getRole_id() {
		return role_id;
	}
	public void setRole_id(int role_id) {
		this.role_id = role_id;
	}
	public String getRole_name() {
		return role_name;
	}
	public void setRole_name(String role_name) {
		this.role_name = role_name;
	}
	public String getSign() {
		return sign;
	}
	public void setSign(String sign) {
		this.sign = sign;
	}

	@Override
	public String toString() {
		return "User [id=" + id + ", user_id=" + user_id + ", account=" + account + ", password=" + password
				+ ", random=" + random + ", public_key=" + public_key + ", private_key=" + private_key
				+ ", organization_name=" + organization_name + ", person_name=" + person_name + ", role_id=" + role_id
				+ ", role_name=" + role_name + ", sign=" + sign + "]";
	}
	//顺序控制
	public interface USERID{};
	public interface ACCOUNT{};
	public interface PASSWORD{};
	public interface RANDOM{};
	public interface PERSONNAME{};
	public interface ROLEID{};
	public interface ROLENAME{};
	public interface SIGN{};
	//该组用于用户登录
	@GroupSequence({ACCOUNT.class, PASSWORD.class}) 
	public interface GroupA{}
	//该组用于添加用户
	@GroupSequence({USERID.class, ROLEID.class,ROLENAME.class,ACCOUNT.class,PASSWORD.class,PERSONNAME.class,RANDOM.class}) 
	public interface GroupB{};
	
}
