package com.fuzamei.service;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import org.apache.poi.util.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.StringUtils;

import com.fuzamei.dao.CapitalTransferDao;
import com.fuzamei.entity.CapitalTransfer;
import com.fuzamei.entity.CapitalTransferCheck;
import com.fuzamei.entity.User;
import com.fuzamei.utils.PageDTO;

@Service
public class CapitalTransferService {
    @Autowired
    private   CapitalTransferDao  capitalTransferDao;
    private static final int ROW_NUM = 10; // 分页每页显示数据的数量
    /**  
     *  查询资金划转表  省分行托管中心指令业务岗
     * @param  
     * @param   
     * @throws Exception  
     */
	public PageDTO selectCapitalTransferTable(Map<String, Object> map){//查询资金划转列表
		int page = 1; // 默认页是第一页
		String fund_name="";//基金名称
		String status_name="";//状态名称
		long startTime = 0; // 开始时间默认0
		long endTime = Long.MAX_VALUE; // 结束时间默认Long最大值
		
		StringUtils.isEmpty(map);
		
		if (!"".equals(map.get("page")) && map.get("page") != null) { // 等于空就直接取第一页
			try {
				page = Integer.parseInt((String) map.get("page"));
				if (page < 1) {
					page = 1;
				}
			} catch (NumberFormatException e) {
				page = 1; // 数据解析异常page还是1
			}
		}
		if (!"".equals(map.get("fund_name")) && map.get("fund_name") != null) { // 等于空就直接取空值
			fund_name = (String) map.get("fund_name");
		}
		if (!"".equals(map.get("status_name")) && map.get("status_name") != null) { // 等于空就直接取空值
			status_name = (String) map.get("status_name");
		}
		
		if (!"".equals(map.get("startTime")) && map.get("startTime") != null) { // 等于空就直接取空值
			try {
				startTime = Long.parseLong((String) map.get("startTime"));
			} catch (NumberFormatException e) {
				startTime = 0; // 数据解析异常startTime还是0
			}
		}
		if (!"".equals(map.get("endTime")) && map.get("endTime") != null) { // 等于空就直接取空值
			try {
				endTime = Long.parseLong((String) map.get("endTime"));
			} catch (NumberFormatException e) {
				endTime = Long.MAX_VALUE; // 数据要是解析异常endTime还是9223372036854775807L
			}
		}
		PageDTO pageDto = new PageDTO(); // 创建分页对象
		Map<String, Object> mapToDao = new LinkedHashMap<String, Object>();
		mapToDao.put("startPage", (page - 1) * ROW_NUM);
		mapToDao.put("fund_name", fund_name);
		mapToDao.put("status_name", status_name);
		if (startTime <= endTime) {
			mapToDao.put("startTime", startTime);
			mapToDao.put("endTime", endTime);
		} else {
			mapToDao.put("startTime", startTime);
			mapToDao.put("endTime", Long.MAX_VALUE);
		}
		
		mapToDao.put("rowNum", ROW_NUM); // 默认每页显示数据是10条，可根据需求修改分页数量
		int  countPage=capitalTransferDao.selectCapitalTransferPage();//资金划转表  总得信息数量页数
		List<CapitalTransfer> CapitalTransferList=capitalTransferDao.selectCapitalTransferTable(mapToDao);
		pageDto.setTotal(countPage);
		pageDto.setRows(CapitalTransferList);
		return pageDto;
		
	}
	//资金划转   点击查看 详情
	public Map<String, Object>  selectChaKanZiJinHuaZhuan(Map<String, Object> map){
		int fund_id=0;
		//int user_id=0;
		if (!"".equals(map.get("fund_id")) && map.get("fund_id") != null) { 
			fund_id =  Integer.parseInt((String)map.get("fund_id"));
		}
		/*if (!"".equals(map.get("user_id")) && map.get("user_id") != null) { 
			user_id =  Integer.parseInt((String)map.get("user_id"));
		}*/
		
		
		 Map<String, Object> mapToDao = new LinkedHashMap<String, Object>();
		  mapToDao.put("fund_id", fund_id);//附件名称    暂时没写
		  //mapToDao.put("user_id", user_id);
		  List<CapitalTransfer> list=capitalTransferDao.selectChaKanZiJinHuaZhuan(mapToDao);
		  List<CapitalTransferCheck> lis= capitalTransferDao.selectCapitalTransferRecord(mapToDao);
		  //List<User> user=capitalTransferDao.selectByPersonName(mapToDao);
		  Map<String, Object> map1=new LinkedHashMap<String, Object>();
		  map1.put("CapitalTransfer", list);//管理人persont_name取不到值  稍做修改 
		  map1.put("CapitalTransferCheck", lis);
		 // map1.put("user", user); 
		return map1;
	}
	@Transactional
	public void insertCheckTransfer(Map<String, Object> map) {
		String check_department="";		//审核部门
		String check_person="";			//审核人
		Integer check_result=null;			//审核结果
		String check_opinion="";			//审核意见
	
		Integer fund_id=null;			//划转资金的id号，要根据这个更新划转资金审核的状态的
		Integer status_id=null;			//划转资金表的状态id号，这个要根据check_result审核结果来判断状态哦
		
		Integer operatorTypeId=null;     ////把操作类型id号-*放到操作记录表中去的
		
		if (!"".equals(map.get("check_department")) && map.get("check_department") != null) { 
			check_department = (String)map.get("check_department");
		}
		if (!"".equals(map.get("check_person")) && map.get("check_person") != null) { 
				check_person = (String)map.get("check_person");
		}
		if (!"".equals(map.get("check_result")) && map.get("check_result") != null) { 
			check_result = Integer.parseInt((String)map.get("check_result"));
	     
		
		}
		if (!"".equals(map.get("check_opinion")) && map.get("check_opinion") != null) { 
			check_opinion = (String)map.get("check_opinion");
	    }
		if (!"".equals(map.get("fund_id")) && map.get("fund_id") != null) { 
			fund_id = Integer.parseInt((String)map.get("fund_id"));
	    }
		if (!"".equals(map.get("status_id")) && map.get("status_id") != null) { 
			status_id = Integer.parseInt((String)map.get("status_id"));
	    }
		
		
	}
}
