package com.fuzamei.web;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.validation.ConstraintViolation;
import javax.validation.Valid;
import javax.validation.Validation;
import javax.validation.Validator;
import javax.validation.ValidatorFactory;

import org.apache.commons.io.FileUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.validation.BindingResult;
import org.springframework.validation.FieldError;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import com.alibaba.fastjson.JSON;
import com.fuzamei.entity.BusinessCheck;
import com.fuzamei.service.BusinessDeclareService;
import com.fuzamei.utils.JSONUtil;
import com.fuzamei.utils.PageDTO;

@Controller
@RequestMapping("/business_declare")
public class BusinessDeclareAction {
	
	@Autowired
	private BusinessDeclareService businessDeclareService;
	
	private static final String SP=File.separator;
	/**
	 * 
	* @Title: uploadValuationPOIByBank
	* @Description: TODO(业务申报功能，需要完成【业务核准表】【尽职调查报告】【产品核准表】【基础性资料】4个文件的上传，插入业务申报表1条数据，插入附件表4条数据，还有插入操作历史1条数据)
	* 				前段以【表单】的形式传过来一组数据：
	* 				businessApproval：对应业务核准表的文件
	* 				responsibleInvestigation：对应尽职调查报告文件
	* 				productApproval：产品核准表文件
	* 				basicData:基础性资料文件
	* 				businessName：业务名称
	* @param @param files
	* @param @param request
	* @param @param businessName                  由经办行写入的业务名称，例如：嘉实活期基金
	* @param @return    设定文件
	* @return Map<String,Object>    返回类型
	* @author ylx
	* @date 2017年12月19日 上午11:23:27
	* @throws
	 */
	@RequestMapping(value="/uploadBusinessMaterialsByBranchBank",method=RequestMethod.POST)
	@ResponseBody
	public Map<String, Object> uploadValuationPOIByBank(@RequestParam("businessApproval") MultipartFile file1,
			@RequestParam("responsibleInvestigation") MultipartFile file2,
			@RequestParam("productApproval") MultipartFile file3,
			@RequestParam("basicData") MultipartFile file4,
			HttpServletRequest request,
			@RequestParam("businessName") String businessName) {
		try {
			String path = request.getServletContext().getRealPath("")+SP+"content";			//SP是系统分隔符
			File dir=new File(path);
			if(!dir.exists()){
				dir.mkdirs();
			}
			
			Map<String, Object> map =new LinkedHashMap<String, Object>();		//这个map用于存储所有要去service的数据
			map.put("businessId", 32323);					//将业务id先写死，到时候还要再进行修改。。。。。TODO
			map.put("bank", "杭州文三路支行");				//先将申报的支行名字写死，到时候还要进行修改。。。。。数据库的字段是bank_id？？？。。。。。TODO
			map.put("businessName", businessName);			//将业务名称先写入map，这个只是用于创建一条业务申请表中的信息，数据来自客户端创建的名称
			
			
			//处理businessApproval(业务核准表)文件的上传功能
			String filename1 = file1.getOriginalFilename();
			String pathFile1=path+SP+filename1;
			File newFile1=new File(pathFile1);
			file1.transferTo(newFile1);						//将---业务核准表---文件上传到制定的文件夹下，目前这个文件夹路径是写死的	
			map.put("busineeApprovalId", 400001);			//将业务核准表的id先写死，和attachment表中表id一致
			map.put("busineeApprovalName",filename1);		//业务核准表名称，用于存在attachment中的附件名
			map.put("urlOfBusineeApproval", SP+"content"+SP+filename1);		//将文件下载路径url通过map传到service层进行校验
			
	//---------------------------------------------------------------------------------------------------------------			
				
			//处理responsibleInvestigation(尽职调查报告)文件的上传功能
			String filename2 = file2.getOriginalFilename();
			String pathFile2=path+SP+filename2;
			File newFile2=new File(pathFile2);
			file2.transferTo(newFile2);													//将---尽职调查报告---文件上传到制定的文件夹下，目前这个文件夹路径是写死的
			map.put("responsibleInvestigationId", 500001);								//将尽职调查报告的id先写死，和attachment表中表id一致
			map.put("responsibleInvestigationName",filename2);							//业务核准表名称，用于存在attachment中的附件名
			map.put("urlOfResponsibleInvestigation", SP+"content"+SP+filename2);		//将文件下载路径url通过map传到service层进行校验
			
	//---------------------------------------------------------------------------------------------------------------		
			
			//处理productApproval(产品核准表)文件的上传功能
			String filename3 = file3.getOriginalFilename();
			String pathFile3=path+SP+filename3;
			File newFile3=new File(pathFile3);
			file3.transferTo(newFile3);											//将---产品核准表---文件上传到制定的文件夹下，目前这个文件夹路径是写死的
			map.put("productApprovalId", 600001);								//将产品核准表的id先写死，和attachment表中表id一致
			map.put("productApprovalName",filename3);							//业务核准表名称，用于存在attachment中的附件名
			map.put("urlOfProductApproval", SP+"content"+SP+filename3);			//将文件下载路径url通过map传到service层进行校验

	//---------------------------------------------------------------------------------------------------------------		
			
			//处理basicData(基础性资料)文件的上传功能
			String filename4 = file4.getOriginalFilename();
			String pathFile4=path+SP+filename4;
			File newFile4=new File(pathFile4);
			file4.transferTo(newFile4);													//将---基础性资料---文件上传到制定的文件夹下，目前这个文件夹路径是写死的
			map.put("basicDataId", 700001);								//将业务核准表的id先写死，和attachment表中表id一致
			map.put("basicDataName",filename4);							//业务核准表名称，用于存在attachment中的附件名
			map.put("urlOfBasicData", SP+"content"+SP+filename4);		//将文件下载路径url通过map传到service层进行校验
				
	//---------------------------------------------------------------------------------------------------------------		
			
			//将经办支行提交的所有数据信息通过map传入service层先进行校验
			businessDeclareService.insertInformationIntoTableByBranchBank(map);
			
			return JSONUtil.getJsonMap(200, true, "上传成功",null); //返回给前端一个map进行前段提示
		} catch (Exception e) {
			return JSONUtil.getJsonMap(500, false, "上传出现异常"+e.getMessage(),null); //返回给前端一个map进行前段提示
		}
	}
	
	
	
	/**
	 * 
	* @Title: queryBusinessDeclareInformation
	* @Description: TODO(业务申报的查看，将所有信息返还给界面)
	* @param @param data
	* @param @return    设定文件
	* @return Map<String,Object>    返回类型
	* @author ylx
	* @date 2017年12月19日 下午4:01:02
	* @throws
	 */
	@RequestMapping(value="/queryBusinessDeclareInformation",method=RequestMethod.POST)
	@ResponseBody
	public Map<String,Object> queryBusinessDeclareInformation(@RequestBody String data){
		
		System.out.println("查询业务申请信息....");
		Map<String, Object> map = JSONUtil.jsonToMap(data);		//将前端传过来的json数据转化为map对象，并将map对象传入service层进行数据校验
		
		PageDTO pageDto = businessDeclareService.queryBusinessDeclareInformation(map);
		
		return JSONUtil.getJsonMap(200, true, "操作成功", pageDto);
	}
	
	/**
	 * 
	* @Title: queryBusinessDeclareInformation
	* @Description: TODO(审核记录的查询，当用户点击查看按钮后，不仅显示了业务申报的信息，还显示了审核记录的信息，这里业务申报的信息直接从前端获取，审核记录根据前端提供的业务id号business_id来进行查询)
	* 这个信息要去业务审核总表中去查询
	* 			前端传过来的json格式
				{
					"businessId":32323
				}
	* @param @param data
	* @param @return    设定文件
	* @return Map<String,Object>    返回类型
	* @author ylx
	* @date 2017年12月19日 下午7:46:44
	* @throws
	 */
	@RequestMapping(value="/queryBusinessCheckInformation",method=RequestMethod.POST)
	@ResponseBody
	public Map<String,Object> queryBusinessCheckInformation(@RequestBody String data){
		
		System.out.println("查询业务审核总表信息....");
		
		Map<String, Object> map = JSONUtil.jsonToMap(data);		//将前端传过来的json数据转化为map对象，并将map对象传入service层进行数据校验
		
		List<BusinessCheck> businessCheckList = businessDeclareService.queryBusinessCheckInformation(map);
		
		return JSONUtil.getJsonMap(200, true, "操作成功", businessCheckList);
	}
	
	
	/**
	 * 
	* @Title: businessDeclareCheckedBy
	* @Description: TODO(审核意见的提交)
	* @param @param data	
	* 数据json包含
	* 		{ 
	* 		 organizationName:二级分行或省分行
	* 		 checkPerson:审核人员
	* 		 checkResult:结果放入check_result字段
	* 		 checkOpinion：审核意见
	* 		 businessId:业务id
	* 		}
	* @param @return    设定文件
	* @return Map<String,Object>    返回类型
	* @author ylx
	* @date 2017年12月19日 下午8:52:35
	* @throws
	 */
	@RequestMapping(value="/businessDeclareCheckedBy",method=RequestMethod.POST)
	@ResponseBody
	public Map<String,Object> businessDeclareCheckedBy(@RequestBody String data){
		
		try {
			System.out.println("添加到业务审核总表信息....");
			
			Map<String, Object> map = JSONUtil.jsonToMap(data);		//将前端传过来的json数据转化为map对象，并将map对象传入service层进行数据校验
			
			businessDeclareService.businessDeclareCheckedBy(map);
			
			return JSONUtil.getJsonMap(200, true, "增加审核意见成功", null);
		} catch (Exception e) {
			return JSONUtil.getJsonMap(500, false, "增加审核意见失败："+e.getMessage(), null);
		}
	}
	
	
	
	                 
	
	/**
	 * 
	* @Title: uploadContractByProvincialBranchBank
	* @Description: TODO(省分行业务部门上传合同的功能实现)
	* 	前端需要传递过来的数据(以表单形式)有以下几个：contract：合同文件
	* 											businessId:业务id号
	* 											
	* 
	* @param @param file
	* @param @param request
	* @param @param businessId
	* @param @return    设定文件
	* @return Map<String,Object>    返回类型
	* @author ylx
	* @date 2017年12月20日 下午4:21:51
	* @throws
	 */
	@RequestMapping(value="/uploadContractByProvincialBranchBank",method=RequestMethod.POST)
	@ResponseBody
	public Map<String, Object> uploadContractByProvincialBranchBank(@RequestParam("contract") MultipartFile file,HttpServletRequest request,
			@RequestParam("businessId") String businessId) {
		try {
			String path = request.getServletContext().getRealPath("")+SP+"content";			//SP是系统分隔符	
			File dir=new File(path);
			if(!dir.exists()){
				dir.mkdirs();
			}
			
			Map<String, Object> map =new LinkedHashMap<String, Object>();		//这个map用于存储所有要去service的数据
			map.put("businessId", businessId);					//将业务id先写死，到时候还要再进行修改。。。。。TODO
			map.put("contractParty", "建行省分行&信托公司");	//合同的签约方。。。。。。。。。。。。。。。。。TODO。。。。。。。。。。。。。。。【这里先写死，可能通过上传的合同文件获取签约方的信息】
			map.put("uploadDepartment", "省分行业务部门");	//上传部门。。。。。。。。。。。。。。。。。。。TODO。。。。。。。【这里先写死，到底是通过session获取还是通过客户端传过来获取？】
			map.put("uploadPerson", "张三丰");				//上传人员。。。。。。。。。。。。。。。。。。。TODO。。。。。。。【这里先写死，到底如何获取上传人的姓名？？？？】
			
			
			String filename = file.getOriginalFilename();
			String pathFile = path+SP+filename;
			File newFile = new File(pathFile);
			file.transferTo(newFile);											//将---合同---文件上传到制定的文件夹下，目前这个文件夹路径是写死的	
			
			map.put("contractId", "800001");									//将合同的id先写死，和attachment表中表id一致
			map.put("contractName",filename);									//合同名称，用于存在attachment中的附件名
			map.put("url", "/content/"+filename);								//将文件下载路径url通过map传到service层进行校验
			map.put("hash", "to be calculated from file on server");			//文件hash值先写死，到时候需要从服务器上的文件获取
			
			map.put("userId", "900000011");											//先将上传人的id号写死，到时候需要动态获取这个信息。。。TODO
			
			businessDeclareService.uploadContractByProvincialBranchBank(map);	//将合同信息插入到【合同提交记录表contract_record、合同状态跟踪表contract_status_tracking、附件表attachment】
			
			return JSONUtil.getJsonMap(200, true, "合同上传成功", null);
		}catch (Exception e) {
			return JSONUtil.getJsonMap(500, false, "合同上传失败:"+e.getMessage(), null);
		}
	}
			
	
	
	/**
	* @Title: download
	* @Description: TODO(实现所有上传的文件的下载功能)
	* @param @param request
	* @param @param response
	* @param @param url
	* @param @return    设定文件
	* @return Map<String,Object>    返回类型
	* @author ylx
	* @date 2017年12月21日 下午2:05:13
	* @throws
	 */
	@RequestMapping(value="/downloadBusinessDeclareFiles")
	@ResponseBody
	public Map<String, Object> download(HttpServletRequest request,HttpServletResponse response,@RequestParam("url") String url) {
		try {
			String fileName = request.getServletContext().getRealPath("")+url; 		//SP是系统分隔符
			InputStream bis = new BufferedInputStream(new FileInputStream(new File(fileName)));  
			String filename = url.substring(url.lastIndexOf("/")+1);  //截取文件名
			filename = URLEncoder.encode(filename,"UTF-8");
			response.addHeader("Content-Disposition", "attachment;filename=" + filename);    
			response.setContentType("multipart/form-data");   
			BufferedOutputStream out = new BufferedOutputStream(response.getOutputStream());
			int len = 0;  
			while((len = bis.read()) != -1){  
			    out.write(len);  
			    out.flush(); 
			}  
			out.close();
			bis.close();
			return JSONUtil.getJsonMap(200, true, "下载成功",null); //返回给前端一个map进行前段提示
		} catch (Exception e) {
			return JSONUtil.getJsonMap(500, true, "下载出现异常",null); //返回给前端一个map进行前段提示
		}
	}
	
	
	/*@RequestMapping(value="/test")
	@ResponseBody
	public Map<String, Object> test(@RequestBody String data){
		try {
			TestBO testBO = JSON.parseObject(data, TestBO.class);
			List<String> list=validate(testBO);
			if(!list.isEmpty()){
				throw new RuntimeException(list.get(0));
			}
			return JSONUtil.getJsonMap(200, true, "成功",null);
		} catch (Exception e) {
			return JSONUtil.getJsonMap(200, true, "失败："+e.getMessage(),null);
		}
	}*/
	
	
	
	
	/**
	 * 上传文件功能模块
	 * @param files
	 * @param request
	 * @return
	 * @throws IllegalStateException
	 * @throws IOException
	 */
	/*
	@RequestMapping(value="/upload",method=RequestMethod.POST)
	@ResponseBody
	public String upload(@RequestParam("file") MultipartFile[] files,HttpServletRequest request) throws IllegalStateException, IOException{
		String path = request.getSession().getServletContext().getRealPath("content");
		File dir=new File(path);
		if(!dir.exists()){
			dir.mkdirs();
		}
		for (MultipartFile file : files) {
			String filename = file.getOriginalFilename();
			String pathFile=path+"/"+filename;
			File newFile=new File(pathFile);
			file.transferTo(newFile);
		}
		
		return "upload success";
	}
	*/
	
	/**
	 * 文件下载功能
	 * @param request
	 * @param response
	 * @throws IOException
	 */
	/*
	@RequestMapping(value="/download")
	public void download(HttpServletRequest request,HttpServletResponse response) throws IOException{
		String fileName = request.getSession().getServletContext().getRealPath("content")+"/"+"demo.sql";
		InputStream bis = new BufferedInputStream(new FileInputStream(new File(fileName)));  
        
        String filename = "下载文件.jpg";  
        
        filename = URLEncoder.encode(filename,"UTF-8");
        
        response.addHeader("Content-Disposition", "attachment;filename=" + filename);    
            
        response.setContentType("multipart/form-data");   
        
        BufferedOutputStream out = new BufferedOutputStream(response.getOutputStream());  
        int len = 0;  
        while((len = bis.read()) != -1){  
            out.write(len);  
            out.flush(); 
        }  
        out.close();
        bis.close();
	}
	*/
	
	
	/**
	 * 
	* @Title: download
	* @Description: TODO(文件下载的另一种方法)
	* @param @param request
	* @param @return
	* @param @throws IOException    设定文件
	* @return ResponseEntity<byte[]>    返回类型
	* @author ylx
	* @date 2017年12月19日 上午10:21:33
	* @throws
	 */
	/*
	@RequestMapping(value = "/download2",produces = "application/octet-stream;charset=UTF-8")
    public ResponseEntity<byte[]> download(HttpServletRequest request) throws IOException {
//        指定文件,必须是绝对路径
    File file = new File(request.getSession().getServletContext().getRealPath("content")+"/"+"demo.sql");
//        下载浏览器响应的那个文件名
    String dfileName = URLEncoder.encode("下载文件.jpg","UTF-8");;
//        下面开始设置HttpHeaders,使得浏览器响应下载
    HttpHeaders headers = new HttpHeaders();
//        设置响应方式
    headers.setContentType(MediaType.APPLICATION_OCTET_STREAM);
//        设置响应文件
    headers.setContentDispositionFormData("attachment", dfileName);
//        把文件以二进制形式写回
    return new ResponseEntity<byte[]>(FileUtils.readFileToByteArray(file), headers, HttpStatus.CREATED);
}
    */
	
	
}
