package com.fuzamei.web;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.fuzamei.entity.CapitalTransfer;
import com.fuzamei.service.CapitalTransferService;
import com.fuzamei.utils.JSONUtil;
import com.fuzamei.utils.PageDTO;

@Controller
@RequestMapping(value = "CapitalTransfer")
public class CapitalTransferAction {
	@Autowired	
	private CapitalTransferService capitalTransferService;
	
	 /**  
     *  查询资金划转表  省分行托管中心指令业务岗
     * @param  
     * @param   
     * @throws Exception  
     */
	@RequestMapping(value = "/selectCapitalTransfer", method = RequestMethod.POST)
	@ResponseBody
	public Map<String, Object> selectCapitalTransfer(@RequestBody String data) {
      //System.out.println("查询资金划转列表数据");
		Map<String, Object> mapResult = new LinkedHashMap<String, Object>();
		Map<String, Object> map = JSONUtil.jsonToMap(data);
		PageDTO pageDto=capitalTransferService.selectCapitalTransferTable(map);
		mapResult = JSONUtil.getJsonMap(200, true, "操作成功", pageDto);

		return mapResult;
	}
	
	/**{ 
	    "fund_id":"1005"   postman 传个id
       }
	 * 资金划转查看详情
	 * @param data
	 * @return
	 */
	@RequestMapping(value="/selectChaKanZiJinHuaZhuan",method=RequestMethod.POST)
	@ResponseBody
	public Map<String,Object> selectChaKanZiJinHuaZhuan(@RequestBody String data){
		//System.out.println("查看资金划转详情信息....");
		Map<String, Object> map = JSONUtil.jsonToMap(data);		//将前端传过来的json数据转化为map对象，并将map对象传入service层进行数据校验
		Map<String, Object> map1= capitalTransferService.selectChaKanZiJinHuaZhuan(map);
		return JSONUtil.getJsonMap(200, true, "操作成功", map1);
		
	}
	/**
	 * 划转资金审核的意见提交
	 * @param data
	 * @return
	 * @return Map<String,Object>返回类型
	 * 
	 */
	@RequestMapping(value="/insertCheckTransfer",method=RequestMethod.POST)
	@ResponseBody
	public Map<String,Object> insertCheckTransfer(@RequestBody String data){
		
		try {
			System.out.println("添加到业务审核总表信息....");
			
			Map<String, Object> map = JSONUtil.jsonToMap(data);		//将前端传过来的json数据转化为map对象，并将map对象传入service层进行数据校验
			
			capitalTransferService.insertCheckTransfer(map);
			
			return JSONUtil.getJsonMap(200, true, "添加审核意见成功", null);
		} catch (Exception e) {
			return JSONUtil.getJsonMap(500, false, "添加审核意见失败："+e.getMessage(), null);
		}
		
	}
	
	
	
}
